<template>
    <el-card shadow="hover" class="card-el" :style="{ padding: '0px' }">
        <template #header>
            <div class="card-header">
                <el-button :icon="Minus" plain type="danger" @click="deleteBareme(index)" />
                <el-input v-model="localBareme.titre" @input="updateTitle" placeholder="Excellent, Bien ..." style="width:75%; margin: 0 10px;" />
            </div>
        </template>
        <div>
            <el-input :value="localBareme.description"
                      v-model="newContent"
                      type="textarea"
                      placeholder="..."
                      input-style="text-align: center;height:85px; max-height: 85px"
                      @input="updateBaremeContent" />
        </div>

        <div class="label-input">
            <el-text size="small" type="info">Max:</el-text>
            <el-text size="small" type="info">Min:</el-text>
        </div>

        <div class="card-footer">
            <el-input-number size="small" v-model="localBareme.maxValue" :min="1" :max="10"
                             input-style="padding: 0;" @change="updateMaxValue(localBareme.maxValue, index)" />
            <el-input-number size="small" v-model="localBareme.minValue" :min="0" :max="localBareme.maxValue - 1"
                             input-style="padding: 0;" @change="updateMinValue(localBareme.minValue, index)" />
            <el-button type="danger" size="small" :icon="Close" @click="clearMinValue(index)" plain circle></el-button>
        </div>

    </el-card>
</template>
<script lang="ts" setup>
    import { computed, ref } from 'vue';
    import { Bareme } from '@/types/entities/creation-grille/Bareme';

    import { Minus, Close } from '@element-plus/icons-vue';

    // eslint-disable-next-line
    const props = defineProps<{
        bareme: Bareme,
        index: number
    }>();

    // eslint-disable-next-line
    const emit = defineEmits(['deleteBareme', 'updateBaremeContent', 'updateBaremeMaxValue', 'updateBaremeMinValue', 'updateBaremeTitle'])

    const newContent = ref<string>("")

    const localBareme = computed(() => props.bareme)

    // Gestion Bareme

    const deleteBareme = (index: number) => {
        emit('deleteBareme', index)
    }

    const updateBaremeContent = () => {
        emit('updateBaremeContent', newContent.value)
    }

    const clearMinValue = (index: number) => {
        emit('updateBaremeMinValue', null, index)
    }

    const updateMaxValue = (value: number, index: number) => {
        emit('updateBaremeMaxValue', value, index)
    }

    const updateMinValue = (value: number, index: number) => {
        emit('updateBaremeMinValue', value, index)
    }

    const updateTitle = () => {
        emit('updateBaremeTitle', localBareme.value.titre)
    }
</script>
<style scoped>
    .card-header {
        display: flex;
        justify-content: space-between;
        align-content: center;
    }

    .card-el {
        max-width: 225px;
        max-height: 235px;
        margin: 10px;
    }

    .card-footer {
        text-align: end;
        display: flex;
        align-items: center;
        gap: 5px;
    }
    .label-input{
        margin: 5% 0 0 0;
        display: flex;
        gap: 30%;
    }
</style>